"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var execa_1 = __importDefault(require("execa"));
var os_1 = require("os");
var path_2 = require("path");
var mustache_1 = __importDefault(require("mustache"));
var v1_1 = __importDefault(require("uuid/v1"));
var shelljs_1 = __importDefault(require("shelljs"));
var debug = require('debug')('press-ready');
var ASSETS_DIR = path_1.default.resolve(__dirname, '..', 'assets');
function isGhostscriptAvailable() {
    return shelljs_1.default.which('gs');
}
exports.isGhostscriptAvailable = isGhostscriptAvailable;
function ghostScript(_a) {
    var inputPath = _a.inputPath, outputPath = _a.outputPath, _b = _a.pdfxDefTemplatePath, pdfxDefTemplatePath = _b === void 0 ? path_1.default.join(ASSETS_DIR, 'PDFX_def.ps.mustache') : _b, _c = _a.sourceIccProfilePath, sourceIccProfilePath = _c === void 0 ? path_1.default.join(ASSETS_DIR, 'JapanColor2001Coated.icc') : _c, _d = _a.grayScale, grayScale = _d === void 0 ? false : _d, _e = _a.enforceOutline, enforceOutline = _e === void 0 ? false : _e, _f = _a.boundaryBoxes, boundaryBoxes = _f === void 0 ? false : _f, _g = _a.title, title = _g === void 0 ? 'Auto-generated PDF (press-ready)' : _g;
    return __awaiter(this, void 0, void 0, function () {
        var workingDir, id, iccProfilePath, pdfxDefPath, pdfxDefTemplateString, pdfxDef, gsCommand, gsOptions, args, command, _h, stdout, stderr, err_1;
        return __generator(this, function (_j) {
            switch (_j.label) {
                case 0:
                    workingDir = os_1.tmpdir();
                    id = v1_1.default();
                    iccProfilePath = path_2.join(workingDir, "press-ready-" + id + ".icc");
                    fs_1.default.copyFileSync(sourceIccProfilePath, iccProfilePath);
                    pdfxDefPath = path_2.join(workingDir, "press-ready-" + id + ".ps");
                    pdfxDefTemplateString = fs_1.default.readFileSync(pdfxDefTemplatePath, 'utf-8');
                    pdfxDef = mustache_1.default.render(pdfxDefTemplateString, {
                        title: title,
                        iccProfilePath: iccProfilePath,
                    });
                    fs_1.default.writeFileSync(pdfxDefPath, pdfxDef, 'utf-8');
                    gsCommand = 'gs';
                    gsOptions = [
                        '-dPDFX',
                        '-dBATCH',
                        '-dNOPAUSE',
                        '-dNOOUTERSAVE',
                        '-sDEVICE=pdfwrite',
                        '-dPDFSTOPONERROR',
                        '-dShowAnnots=false',
                        '-dPDFSETTINGS=/prepress',
                        '-dPrinted',
                        '-r600',
                        '-dGrayImageResolution=600',
                        '-dMonoImageResolution=600',
                        '-dColorImageResolution=600',
                        "-sOutputFile=" + outputPath,
                    ];
                    if (boundaryBoxes) {
                        gsOptions.push('-dUseCropBox', '-dUseTrimBox', '-dUseBleedBox');
                    }
                    if (enforceOutline) {
                        gsOptions.push('-dNoOutputFonts');
                    }
                    if (grayScale) {
                        gsOptions.push('-sProcessColorModel=DeviceGray', '-sColorConversionStrategy=Gray', '-sColorConversionStrategyForImages=Gray');
                    }
                    else {
                        gsOptions.push('-sProcessColorModel=DeviceCMYK', '-sColorConversionStrategy=CMYK', '-sColorConversionStrategyForImages=CMYK', '-dOverrideICC', "-sOutputICCProfile=" + iccProfilePath);
                    }
                    args = __spreadArrays(gsOptions, [pdfxDefPath, inputPath]);
                    command = [gsCommand, args];
                    debug(gsCommand, args.join(' '));
                    _j.label = 1;
                case 1:
                    _j.trys.push([1, 3, 4, 5]);
                    return [4 /*yield*/, execa_1.default.apply(void 0, command)];
                case 2:
                    _h = _j.sent(), stdout = _h.stdout, stderr = _h.stderr;
                    return [2 /*return*/, {
                            command: command,
                            rawOutput: stdout,
                            rawError: stderr,
                        }];
                case 3:
                    err_1 = _j.sent();
                    return [2 /*return*/, {
                            command: command,
                            rawOutput: err_1.stdout,
                            rawError: err_1.stderr,
                        }];
                case 4:
                    fs_1.default.unlinkSync(iccProfilePath);
                    fs_1.default.unlinkSync(pdfxDefPath);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports.ghostScript = ghostScript;
