"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var execa_1 = __importDefault(require("execa"));
var shelljs_1 = __importDefault(require("shelljs"));
var BOX_COLUMNS = [
    'MediaBox',
    'CropBox',
    'BleedBox',
    'TrimBox',
    'ArtBox',
];
var ParserError = /** @class */ (function (_super) {
    __extends(ParserError, _super);
    function ParserError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return ParserError;
}(Error));
exports.ParserError = ParserError;
function isPdfFontsAvailable() {
    return shelljs_1.default.which('pdffonts');
}
exports.isPdfFontsAvailable = isPdfFontsAvailable;
function pdfFonts(filePath) {
    return __awaiter(this, void 0, void 0, function () {
        var cmd, result, maxLineLength, columns, counter, scraper, fonts;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, execa_1.default('pdffonts', [filePath])];
                case 1:
                    cmd = _a.sent();
                    result = cmd.stdout.split('\n');
                    if (!/^name/.test(result[0])) {
                        throw new ParserError('Parse Error');
                    }
                    if (result.length < 3) {
                        return [2 /*return*/, { rawResponse: result, fonts: [] }];
                    }
                    maxLineLength = result[0].length;
                    columns = result[0].split(/(?<!object)\s+/);
                    counter = result[1]
                        .split(' ')
                        .map(function (hyp) { return hyp.length; })
                        .reduce(function (acum, cur, i) {
                        acum.push(cur + (i == 0 ? 0 : acum[i - 1]) + 1);
                        return acum;
                    }, []);
                    scraper = function (line, column) {
                        var extraPad = 0;
                        if (line.length > maxLineLength) {
                            extraPad = line.indexOf(' ') - counter[0];
                        }
                        return line
                            .substring(counter[columns.indexOf(column) - 1] + extraPad || 0, counter[columns.indexOf(column)] + extraPad)
                            .trim();
                    };
                    fonts = result.slice(2).map(function (line) {
                        return Object.assign.apply(Object, __spreadArrays([{}], columns.map(function (column) {
                            var _a;
                            return (_a = {},
                                _a[column] = scraper(line, column),
                                _a);
                        })));
                    });
                    return [2 /*return*/, { rawResponse: result, fonts: fonts }];
            }
        });
    });
}
exports.pdfFonts = pdfFonts;
function pdfInfo(filePath) {
    var _a, _b, _c, _d, _e;
    return __awaiter(this, void 0, void 0, function () {
        var cmd, lines, rawResult, result, labels, _i, BOX_COLUMNS_1, column, size;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0: return [4 /*yield*/, execa_1.default('pdfinfo', ['-box', filePath])];
                case 1:
                    cmd = _f.sent();
                    lines = cmd.stdout.split('\n');
                    rawResult = Object.assign.apply(Object, __spreadArrays([{}], lines
                        .map(function (line) { return line.split(/:\s+/); })
                        .map(function (arr) {
                        var _a;
                        return (_a = {}, _a[arr[0]] = arr[1], _a);
                    })));
                    result = {};
                    labels = ['bottomLeftX', 'bottomLeftY', 'topRightX', 'topRightY'];
                    for (_i = 0, BOX_COLUMNS_1 = BOX_COLUMNS; _i < BOX_COLUMNS_1.length; _i++) {
                        column = BOX_COLUMNS_1[_i];
                        result[column] = Object.assign.apply(Object, __spreadArrays([{}], rawResult[column]
                            .split(/\s+/)
                            .map(function (val, i) {
                            var _a;
                            return (_a = {}, _a[labels[i]] = parseFloat(val), _a);
                        })));
                    }
                    // parse pages
                    result['Pages'] = parseInt(rawResult['Pages'], 10);
                    size = rawResult['Page size'].match(/(\d+) x (\d+)/);
                    result['Page size'] = {
                        width: parseInt((_b = (_a = size) === null || _a === void 0 ? void 0 : _a[1], (_b !== null && _b !== void 0 ? _b : '0')), 10),
                        height: parseInt((_d = (_c = size) === null || _c === void 0 ? void 0 : _c[2], (_d !== null && _d !== void 0 ? _d : '0')), 10),
                        raw: (_e = size) === null || _e === void 0 ? void 0 : _e.input,
                    };
                    // parse pdf version
                    result['PDF version'] = parseFloat(rawResult['PDF version']);
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.pdfInfo = pdfInfo;
